var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { jsx as _jsx, Fragment as _Fragment } from "react/jsx-runtime";
import { forwardRef } from "react";
import { FORM_SCHEMA_SYMBOL, FIELD_SCHEMA_SYMBOL, CHECKED_INPUT_TYPES } from "../constants";
import { isInputElement, isSelectElement, isTextAreaElement, deepObjectEntries, removeDuplicateElements, } from "./utils";
export function formSchema(schema) {
    var _a;
    if (schema[FORM_SCHEMA_SYMBOL]) {
        return schema;
    }
    var entries = deepObjectEntries(schema, function (_, value) { return !isFieldSchema(value) && !isFieldValuePrimitive(value); });
    var fields = entries
        .filter(function (_a) {
        var _b = __read(_a, 2), value = _b[1];
        return isFieldValuePrimitive(value) || isFieldSchema(value);
    })
        .map(function (_a) {
        var _b = __read(_a, 2), key = _b[0], value = _b[1];
        return [
            key,
            isFieldValuePrimitive(value) ? field({ defaultValue: value }) : value,
        ];
    });
    var groups = entries
        .filter(function (_a) {
        var _b = __read(_a, 1), entryKey = _b[0];
        return fields.every(function (_a) {
            var _b = __read(_a, 1), key = _b[0];
            return key !== entryKey;
        });
    })
        .map(function (_a) {
        var _b = __read(_a, 1), entryKey = _b[0];
        return [
            "".concat(entryKey, ".*"),
            fields.filter(function (_a) {
                var _b = __read(_a, 1), key = _b[0];
                return key.includes(entryKey);
            }).map(function (_a) {
                var _b = __read(_a, 1), key = _b[0];
                return key;
            }),
        ];
    });
    return _a = {},
        _a[FORM_SCHEMA_SYMBOL] = { fields: Object.fromEntries(fields), groups: Object.fromEntries(groups) },
        _a;
}
export function field(schema) {
    var _a;
    if (schema[FIELD_SCHEMA_SYMBOL]) {
        return schema;
    }
    return _a = {},
        _a[FIELD_SCHEMA_SYMBOL] = schema,
        _a;
}
export function storeSchema(object) {
    return Object.entries(object).reduce(function (acc, _a) {
        var _b;
        var _c = __read(_a, 2), key = _c[0], defaultValue = _c[1];
        return (__assign(__assign({}, acc), (_b = {}, _b[key] = {
            value: defaultValue,
            set: function (value) {
                this.value = value;
            },
        }, _b)));
    }, {});
}
export function validateFactory(validateFn) {
    return validateFn;
}
export function validationChain() {
    var _this = this;
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return function (value, fieldName) { return __awaiter(_this, void 0, void 0, function () {
        var error, args_1, args_1_1, validate, e_1_1;
        var e_1, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    error = "";
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 6, 7, 8]);
                    args_1 = __values(args), args_1_1 = args_1.next();
                    _b.label = 2;
                case 2:
                    if (!!args_1_1.done) return [3 /*break*/, 5];
                    validate = args_1_1.value;
                    return [4 /*yield*/, Promise.resolve(validate(value, fieldName))];
                case 3:
                    error = _b.sent();
                    if (error) {
                        return [3 /*break*/, 5];
                    }
                    _b.label = 4;
                case 4:
                    args_1_1 = args_1.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_1_1 = _b.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (args_1_1 && !args_1_1.done && (_a = args_1.return)) _a.call(args_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 8: return [2 /*return*/, error];
            }
        });
    }); };
}
export function fieldFactory(alias, def) {
    return forwardRef(function (_a, ref) {
        var as = _a.as, rest = __rest(_a, ["as"]);
        var Component = alias[def || as];
        return _jsx(_Fragment, { children: Component ? _jsx(Component, __assign({ ref: ref }, rest), void 0) : null }, void 0);
    });
}
export function syncFieldsValues(fields, value) {
    if (Array.isArray(value)) {
        fields.forEach(function (field) {
            if (isSelectElement(field)) {
                field
                    .querySelectorAll("option")
                    .forEach(function (option) { return (option.selected = value.includes(option.value)); });
            }
            else if (isInputElement(field) || isTextAreaElement(field)) {
                if (isInputElement(field) && CHECKED_INPUT_TYPES.includes(field.type)) {
                    field.checked = value.includes(field.value);
                }
                else {
                    field.value = value[0] || "";
                }
            }
        });
    }
    else if (typeof value === "boolean") {
        fields.forEach(function (field) {
            if (isInputElement(field)) {
                field.checked = value;
            }
        });
    }
    else {
        fields.forEach(function (field) {
            if (isSelectElement(field)) {
                field
                    .querySelectorAll("option")
                    .forEach(function (option) { return (option.selected = value === option.value); });
            }
            else if (isInputElement(field) && CHECKED_INPUT_TYPES.includes(field.type)) {
                field.checked = field.value === value;
            }
            else if (isInputElement(field) || isTextAreaElement(field)) {
                field.value = value;
            }
        });
    }
}
export function collectFieldsValues(field, value) {
    if (Array.isArray(value)) {
        if (isSelectElement(field)) {
            var selectedOptionsValues = Array.from(field.selectedOptions).map(function (option) { return option.value; });
            return field.multiple
                ? removeDuplicateElements(__spreadArray(__spreadArray([], __read(value), false), __read(selectedOptionsValues), false))
                : removeDuplicateElements(selectedOptionsValues);
        }
        else if (isInputElement(field) && CHECKED_INPUT_TYPES.includes(field.type)) {
            return removeDuplicateElements(field.checked ? __spreadArray(__spreadArray([], __read(value), false), [String(field.value)], false) : value.filter(function (value) { return value !== field.value; }));
        }
        else if (isInputElement(field) || isTextAreaElement(field)) {
            return [field.value || ""];
        }
    }
    else if (typeof value === "boolean" && isInputElement(field)) {
        return Boolean(field.checked);
    }
    return String(field.value);
}
export function isFieldSchema(object) {
    return Boolean(object[FIELD_SCHEMA_SYMBOL]);
}
export function isFieldValuePrimitive(object) {
    return Array.isArray(object) || ["string", "boolean"].includes(typeof object);
}
