var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { useCallback, useEffect, useMemo, useRef } from "react";
import { useLocalObservable } from "mobx-react-lite";
import isDeepEqual from "react-fast-compare";
import { FORM_SCHEMA_SYMBOL, FIELD_SCHEMA_SYMBOL } from "../constants";
import { field, formSchema, storeSchema, syncFieldsValues, collectFieldsValues, isFieldValuePrimitive, } from "./helpers";
import { mergeCallbacks, mergeRefs, pickProperties, removeDuplicateElements, removeUnusedElement, unflattenObject, } from "./utils";
export function useLocalStore(base) {
    return useLocalObservable(function () { return storeSchema(base); });
}
export function useFormix(schema) {
    var _this = this;
    var schemaRef = useRef(schema);
    var formElementsRef = useRef({});
    if (!isDeepEqual(schemaRef.current, schema) || schema !== schemaRef.current) {
        schemaRef.current = schema;
    }
    var preparedSchema = useMemo(function () { return formSchema(schemaRef.current); }, 
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [schemaRef.current]);
    var schemaContent = useMemo(function () { return preparedSchema[FORM_SCHEMA_SYMBOL]; }, [preparedSchema]);
    var schemaFields = useMemo(function () { return schemaContent.fields; }, [schemaContent]);
    var schemaGroups = useMemo(function () { return schemaContent.groups; }, [schemaContent]);
    var fieldsNames = useMemo(function () { return Object.keys(schemaFields); }, [schemaFields]);
    var pickFieldSchema = useCallback(function (name) {
        return schemaFields[name][FIELD_SCHEMA_SYMBOL];
    }, [schemaFields]);
    var pickGroupSchema = useCallback(function (name) {
        return schemaGroups[name];
    }, [schemaGroups]);
    var reduceFieldsNames = useCallback(function (callback) {
        return fieldsNames.reduce(function (acc, key) { return callback(acc, key); }, {});
    }, [fieldsNames]);
    var defaultErrors = useMemo(function () { return reduceFieldsNames(function (acc, name) {
        var _a;
        return (__assign(__assign({}, acc), (_a = {}, _a[name] = "", _a)));
    }); }, [reduceFieldsNames]);
    var defaultValues = useMemo(function () {
        return reduceFieldsNames(function (acc, name) {
            var _a;
            var _b;
            return (__assign(__assign({}, acc), (_a = {}, _a[name] = (_b = pickFieldSchema(name).defaultValue) !== null && _b !== void 0 ? _b : "", _a)));
        });
    }, [pickFieldSchema, reduceFieldsNames]);
    var fieldsValidates = useMemo(function () {
        return reduceFieldsNames(function (acc, name) {
            var _a;
            return (__assign(__assign({}, acc), (_a = {}, _a[name] = pickFieldSchema(name).validate || null, _a)));
        });
    }, [pickFieldSchema, reduceFieldsNames]);
    var errorsStore = useLocalStore(defaultErrors);
    var valuesStore = useLocalStore(defaultValues);
    var connectFormElement = useCallback(function (name, element) {
        var formElements = formElementsRef.current;
        if (!formElements[name]) {
            formElements[name] = [];
        }
        if (element) {
            formElements[name].push(element);
        }
        formElements[name] = removeDuplicateElements(removeUnusedElement(formElements[name]));
    }, []);
    var syncFormFields = useCallback(function (name, value) {
        var formElements = formElementsRef.current;
        if (formElements[name] && formElements[name].length) {
            syncFieldsValues(formElements[name], value);
        }
    }, []);
    var setValues = useCallback(function (values) {
        fieldsNames.forEach(function (name) {
            var value = values[name];
            if (isFieldValuePrimitive(value)) {
                valuesStore[name].set(value);
                syncFormFields(name, value);
            }
        });
    }, [fieldsNames, syncFormFields, valuesStore]);
    var setValue = useCallback(function (name, value) {
        var _a;
        var newValue = typeof value === "function" ? value(valuesStore[name].value) : value;
        setValues((_a = {}, _a[name] = newValue, _a));
    }, [setValues, valuesStore]);
    var getValue = useCallback(function (name) {
        return valuesStore[name].value;
    }, [valuesStore]);
    var getUnflattenValues = useCallback(function () {
        return unflattenObject(defaultValues, function (key) { return valuesStore[key].value; });
    }, [defaultValues, valuesStore]);
    var getValues = useCallback(function () {
        return reduceFieldsNames(function (acc, name) {
            var _a;
            return (__assign(__assign({}, acc), (_a = {}, _a[name] = getValue(name), _a)));
        });
    }, [getValue, reduceFieldsNames]);
    var setErrors = useCallback(function (errors) {
        fieldsNames.forEach(function (name) {
            var error = errors[name];
            if (typeof error === "string") {
                errorsStore[name].set(error);
            }
        });
    }, [errorsStore, fieldsNames]);
    var setError = useCallback(function (name, error) {
        errorsStore[name].set(error);
    }, [errorsStore]);
    var getErrors = useCallback(function () {
        return reduceFieldsNames(function (acc, name) {
            var _a;
            return (__assign(__assign({}, acc), (_a = {}, _a[name] = errorsStore[name].value, _a)));
        });
    }, [errorsStore, reduceFieldsNames]);
    var getError = useCallback(function (name) {
        return errorsStore[name].value;
    }, [errorsStore]);
    var createRefHandler = useCallback(function (name) { return function (element) {
        connectFormElement(name, element);
        syncFormFields(name, valuesStore[name].value);
    }; }, [connectFormElement, syncFormFields, valuesStore]);
    var createChangeHandler = useCallback(function (name) { return function (event) {
        var field = event.target;
        var value = collectFieldsValues(field, valuesStore[name].value);
        setValue(name, value);
        setError(name, "");
    }; }, [setError, setValue, valuesStore]);
    var bind = useCallback(function (name, options) {
        return {
            name: (options === null || options === void 0 ? void 0 : options.newName) || name,
            ref: mergeRefs(createRefHandler(name), options === null || options === void 0 ? void 0 : options.ref),
            onChange: mergeCallbacks(createChangeHandler(name), options === null || options === void 0 ? void 0 : options.onChange),
        };
    }, [createChangeHandler, createRefHandler]);
    var getValidationErrors = useCallback(function (target) { return __awaiter(_this, void 0, void 0, function () {
        var fields, validates, filteredValidates, validatesKeys, isValidatesNotEmpty, validatesPromises, validatesResults, haveSomeErrors;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fields = target
                        ? pickGroupSchema(target)
                            ? pickGroupSchema(target)
                            : [target]
                        : fieldsNames;
                    validates = pickProperties.apply(void 0, __spreadArray([fieldsValidates], __read(fields), false));
                    filteredValidates = Object.fromEntries(Object.entries(validates).filter(function (_a) {
                        var _b = __read(_a, 2), validate = _b[1];
                        return validate;
                    }));
                    validatesKeys = Object.keys(filteredValidates);
                    isValidatesNotEmpty = validatesKeys.length > 0;
                    if (!isValidatesNotEmpty) return [3 /*break*/, 2];
                    validatesPromises = validatesKeys.map(function (name) {
                        return filteredValidates[name](valuesStore[name].value, {
                            name: name,
                            getFlattenValues: getValues,
                            getUnflattenValues: getUnflattenValues,
                        });
                    });
                    return [4 /*yield*/, Promise.allSettled(validatesPromises)];
                case 1:
                    validatesResults = (_a.sent());
                    haveSomeErrors = validatesResults.some(function (result) { return result.value; });
                    if (haveSomeErrors) {
                        return [2 /*return*/, validatesResults.reduce(function (acc, result, index) {
                                var _a;
                                var name = validatesKeys[index];
                                return __assign(__assign({}, acc), (_a = {}, _a[name] = result.value ? String(result.value) : undefined, _a));
                            }, {})];
                    }
                    _a.label = 2;
                case 2: return [2 /*return*/, {}];
            }
        });
    }); }, [fieldsNames, fieldsValidates, getUnflattenValues, getValues, pickGroupSchema, valuesStore]);
    var validate = useCallback(function (target) { return __awaiter(_this, void 0, void 0, function () {
        var errors, errorsKeys, haveSomeErrors;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getValidationErrors(target)];
                case 1:
                    errors = _a.sent();
                    errorsKeys = Object.keys(errors);
                    haveSomeErrors = errorsKeys.length > 0;
                    if (haveSomeErrors) {
                        setErrors(errors);
                        return [2 /*return*/, false];
                    }
                    return [2 /*return*/, true];
            }
        });
    }); }, [getValidationErrors, setErrors]);
    var isValid = useCallback(function (target) { return __awaiter(_this, void 0, void 0, function () {
        var errors, errorsKeys, haveSomeErrors;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getValidationErrors(target)];
                case 1:
                    errors = _a.sent();
                    errorsKeys = Object.keys(errors);
                    haveSomeErrors = errorsKeys.length > 0;
                    return [2 /*return*/, !haveSomeErrors];
            }
        });
    }); }, [getValidationErrors]);
    var $ = useCallback(function (name) {
        return {
            bind: function (options) { return bind(name, options); },
            isValid: function () { return isValid(name); },
            validate: function () { return validate(name); },
            getError: function () { return getError(name); },
            getValue: function () { return getValue(name); },
            setError: function (error) { return setError(name, error); },
            setValue: function (value) { return setValue(name, value); },
        };
    }, [bind, getError, getValue, isValid, setError, setValue, validate]);
    useEffect(function () {
        setValues(defaultValues);
        setErrors(defaultErrors);
    }, [defaultErrors, defaultValues, setErrors, setValues]);
    return {
        $: $,
        bind: bind,
        isValid: isValid,
        getError: getError,
        getErrors: getErrors,
        setError: setError,
        setErrors: setErrors,
        getValue: getValue,
        getValues: getValues,
        getUnflattenValues: getUnflattenValues,
        setValue: setValue,
        setValues: setValues,
        validate: validate,
    };
}
export function useField(name, schemaOrDefaultValue) {
    var _a;
    var $ = useFormix((_a = {},
        _a[name] = isFieldValuePrimitive(schemaOrDefaultValue)
            ? field({ defaultValue: schemaOrDefaultValue })
            : field(schemaOrDefaultValue),
        _a)).$;
    return $(name);
}
