var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
export function deepObjectEntries(object, conditionFn) {
    var e_1, _a;
    var keys = Object.keys(object);
    var entries = [];
    var _loop_1 = function (key) {
        var value = object[key];
        entries.push([key, value]);
        if (typeof value === "object" && (!conditionFn || conditionFn(key, value))) {
            var subEntires = deepObjectEntries(value, conditionFn);
            entries.push.apply(entries, __spreadArray([], __read(subEntires.map(function (_a) {
                var _b = __read(_a, 2), entryKey = _b[0], value = _b[1];
                return ["".concat(key, ".").concat(entryKey), value];
            })), false));
        }
    };
    try {
        for (var keys_1 = __values(keys), keys_1_1 = keys_1.next(); !keys_1_1.done; keys_1_1 = keys_1.next()) {
            var key = keys_1_1.value;
            _loop_1(key);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (keys_1_1 && !keys_1_1.done && (_a = keys_1.return)) _a.call(keys_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return entries;
}
export function excludeProperties(object) {
    var keys = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        keys[_i - 1] = arguments[_i];
    }
    var entries = Object.entries(object);
    var filteredEntries = entries.filter(function (_a) {
        var _b = __read(_a, 1), key = _b[0];
        return !keys.includes(key);
    });
    return Object.fromEntries(filteredEntries);
}
export function pickProperties(object) {
    var keys = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        keys[_i - 1] = arguments[_i];
    }
    var entries = Object.entries(object);
    var filteredEntries = entries.filter(function (_a) {
        var _b = __read(_a, 1), key = _b[0];
        return keys.includes(key);
    });
    return Object.fromEntries(filteredEntries);
}
export function mergeRefs() {
    var refs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        refs[_i] = arguments[_i];
    }
    var filteredRefs = refs.filter(Boolean);
    if (filteredRefs.length === 0) {
        return null;
    }
    return function (instance) {
        var e_2, _a;
        try {
            for (var filteredRefs_1 = __values(filteredRefs), filteredRefs_1_1 = filteredRefs_1.next(); !filteredRefs_1_1.done; filteredRefs_1_1 = filteredRefs_1.next()) {
                var ref = filteredRefs_1_1.value;
                if (typeof ref === "function") {
                    ref(instance);
                }
                else if (ref) {
                    ref.current = instance;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (filteredRefs_1_1 && !filteredRefs_1_1.done && (_a = filteredRefs_1.return)) _a.call(filteredRefs_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
}
export function removeDuplicateElements(array) {
    return Array.from(new Set(array));
}
export function removeUnusedElement(elements) {
    return elements.filter(function (element) { return document.body.contains(element); });
}
export function isSelectElement(element) {
    return element.tagName.toLowerCase() === "select";
}
export function isTextAreaElement(element) {
    return element.tagName.toLocaleLowerCase() === "textarea";
}
export function isInputElement(element) {
    return element.tagName.toLocaleLowerCase() === "input";
}
export function mergeCallbacks() {
    var callbacks = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        callbacks[_i] = arguments[_i];
    }
    var filteredCallbacks = callbacks.filter(Boolean);
    if (filteredCallbacks.length === 0) {
        return null;
    }
    return function () {
        var e_3, _a;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        try {
            for (var filteredCallbacks_1 = __values(filteredCallbacks), filteredCallbacks_1_1 = filteredCallbacks_1.next(); !filteredCallbacks_1_1.done; filteredCallbacks_1_1 = filteredCallbacks_1.next()) {
                var callback = filteredCallbacks_1_1.value;
                callback.apply(void 0, __spreadArray([], __read(args), false));
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (filteredCallbacks_1_1 && !filteredCallbacks_1_1.done && (_a = filteredCallbacks_1.return)) _a.call(filteredCallbacks_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
    };
}
export function unflattenObject(object, getValue) {
    var e_4, _a;
    var result = {};
    var keys = Object.keys(object);
    var temp;
    var substrings;
    try {
        for (var keys_2 = __values(keys), keys_2_1 = keys_2.next(); !keys_2_1.done; keys_2_1 = keys_2.next()) {
            var key = keys_2_1.value;
            substrings = key.split(".");
            temp = result;
            for (var i = 0; i < substrings.length - 1; i++) {
                var substring = substrings[i];
                if (!(substring in temp)) {
                    if (Number.isFinite(substrings[i + 1])) {
                        temp[substring] = [];
                    }
                    else {
                        temp[substring] = {};
                    }
                }
                temp = temp[substring];
            }
            temp[substrings[substrings.length - 1]] = getValue ? getValue(key) : object[key];
        }
    }
    catch (e_4_1) { e_4 = { error: e_4_1 }; }
    finally {
        try {
            if (keys_2_1 && !keys_2_1.done && (_a = keys_2.return)) _a.call(keys_2);
        }
        finally { if (e_4) throw e_4.error; }
    }
    return result;
}
